/*
 * Created by victoria on 2021-05-12.
 */

#pragma once

#include <QXmppPubSubIq.h>

#include <QDateTime>
#include <QXmppMessage.h>

namespace QXmpp::Omemo {

    class MessageKey {
    public:
        [[nodiscard]] QXmppElement toXml() const;

        int receivingDeviceId{};
        bool prekey{};
        QString key{};
    };

    class EncryptedMessage {
    public:
        [[nodiscard]] QXmppElement header() const;
        [[nodiscard]] QXmppElement content() const;
        [[nodiscard]] QXmppElement toXml() const;
        [[nodiscard]] QXmppElement payload() const;

        int fromDeviceId{};

        QList<MessageKey> keys{};
        QString from{};
        QString to{};
        QDateTime timestamp{};

        QString iv{};

        QXmppMessage message{};
    };

} // namespace QXmpp::Omemo
