/*
 * Created by victoria on 2021-05-13.
 */

#pragma once

#include <signal/signal_protocol.h>

#include "qomemo/device_service.h"

namespace Signal::Store {

    class PreKeyStore {
    public:
        explicit PreKeyStore(QSharedPointer<QXmpp::Omemo::Database> database);

        int containsPreKey(uint32_t pre_key_id);
        int loadPreKey(signal_buffer **record, uint32_t pre_key_id);
        int storePreKey(uint32_t pre_key_id, uint8_t *record, size_t record_len);
        int removePreKey(uint32_t pre_key_id);

        void fillCallbacks(signal_protocol_pre_key_store &store);

    private:
        QSharedPointer<QXmpp::Omemo::Database> database;
    };

} // namespace Signal::Store
